// Copyright 2013 Canonical Ltd.  This software is licensed under the
// GNU Lesser General Public License version 3 (see the file COPYING).

package gwacl

import (
    "net/http"
    "strings"
)

var headers_to_sign = []string{
    "Content-Encoding",
    "Content-Language",
    "Content-Length",
    "Content-MD5",
    "Content-Type",
    "Date",
    "If-Modified-Since",
    "If-Match",
    "If-None-Match",
    "If-Unmodified-Since",
    "Range",
}

func signRequest(req *http.Request, account_name, account_key string) {

}

func composeStringToSign(req *http.Request) string {
    //request.verb + composeHeaders(req) + composeCanonicalizedResource(req)
    return ""
}

func composeHeaders(req *http.Request) string {
    result := ""
    for _, header_name := range headers_to_sign {
        result += req.Header.Get(header_name)
        result += "\n"
    }
    return result
}

func composeCanonicalizedResource(req *http.Request, account_name string) string {
    /*
       Beginning with an empty string (""), append a forward slash (/), followed by the name of the account that owns the resource being accessed.

       Append the resource's encoded URI path, without any query parameters.

       Retrieve all query parameters on the resource URI, including the comp parameter if it exists.

       Convert all parameter names to lowercase.

       Sort the query parameters lexicographically by parameter name, in ascending order.

       URL-decode each query parameter name and value.

       Append each query parameter name and value to the string in the following format, making sure to include the colon (:) between the name and the value:

       parameter-name:parameter-value

       If a query parameter has more than one value, sort all values lexicographically, then include them in a comma-separated list:

       parameter-name:parameter-value-1,parameter-value-2,parameter-value-n

       Append a new line character (\n) after each name-value pair. */
    path := req.URL.Path
    if !strings.HasPrefix(path, "/") {
        path = "/" + path
    }
    return "/" + account_name + path
}
